--- include/config.h    Sat Nov 17 19:48:03 2001
+++ include/config.h    Tue Jan 15 18:08:03 2002
@@ -237,6 +237,17 @@
  */
 #define OPERSPOOF
 
+/* SERVER_WITHOUT_RIGHTS
+ * This patchset is useful for servers without rights, i.e. without 
+ * permission to have O:lines, OR, for servers which have plenty of 
+ * sensible and reliable local opers:)
+ * It enables the use of the following commands: /close, /hash, /htm.
+ * +D flag in their o:line is required however.
+ * --Himika
+ */
+
+#define SERVER_WITHOUT_RIGHTS
+
 /* DCCFILECHECK
  * DCC SEND protection against viruses/tojans
  * The irc daemon checks all commands like "/CTCP nick DCC SEND file.ext"
--- src/hash.c  Tue Feb  1 02:44:11 2000
+++ src/hash.c  Tue Jan 15 18:18:55 2002
@@ -460,7 +460,11 @@
   char  hash_log_file[256];
   char  timebuffer[MAX_DATE_STRING];
 
+#ifdef SERVER_WITHOUT_RIGHTS
+  if ((!MyClient(sptr) || !IsOper(sptr)) && (!MyClient(sptr) || !IsLocOp(sptr) || !IsOperDie(sptr)))
+#else
   if (!MyClient(sptr) || !IsOper(sptr))
+#endif
     {
       sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
       return 0;
--- src/m_close.c       Fri Jul 30 07:01:32 1999
+++ src/m_close.c       Tue Jan 15 18:13:39 2002
@@ -97,7 +97,11 @@
   int            i;
   int            closed = 0;
 
+#ifdef SERVER_WITHOUT_RIGHTS
+  if ((!MyClient(sptr) || !IsOper(sptr)) && (!MyClient(sptr) || !IsLocOp(sptr) || !IsOperDie(sptr)))
+#else
   if (!MyOper(sptr))
+#endif
     {
       sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
       return 0;
--- src/m_htm.c Thu Jan  4 17:23:09 2001
+++ src/m_htm.c Tue Jan 15 18:17:06 2002
@@ -99,7 +99,11 @@
 {
   char *command;
 
+#ifdef SERVER_WITHOUT_RIGHTS
+  if ((!MyClient(sptr) || !IsOper(sptr)) && (!MyClient(sptr) || !IsLocOp(sptr) || !IsOperDie(sptr)))
+#else
   if (!MyClient(sptr) || !IsOper(sptr))
+#endif
     {
       sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
       return 0;
--- src/s_user.c        Fri Nov 23 21:46:47 2001
+++ src/s_user.c        Tue Jan 15 18:45:05 2002
@@ -2078,7 +2078,8 @@
                                     FLAGS2_OPER_UNKLINE|
                                     FLAGS2_OPER_GLINE|
                                     FLAGS2_OPER_N|
-                                    FLAGS2_OPER_K);
+                                    FLAGS2_OPER_K|
+                                   FLAGS2_OPER_DIE);
                   while(cur_cptr)
                     {
                       if(sptr == cur_cptr) 

